
/* Define Maximum */
#define SCREEN_WIDTH_MAX            16
#define SCREEN_HEIGHT_MAX            8
#define LEN_BARCODE              16    /* ִ ڵ        */
#define LEN_DATE                 8    /* ¥ 19961129      */
#define LEN_DATE_CHAR           10    /* ¥ 1996/11/29    */
#define LEN_TIME                 6    /* ð 1350          */
#define LEN_TIME_CHAR           10    /* ð 13:50         */
#define LEN_FILE_NAME           11
#define LEN_YY_NO               7
#define LEN_SJ_NO               9
#define LEN_ES_NO               7
#define LEN_CT_NO               3
#define LEN_ZO_NO               4
#define LEN_DATA_RECORD         24
#define LEN_DATA_MASTER         40
#define SOH                   0x01
#define STX                   0x02
#define ETX                   0x03
#define EOT                   0x04
#define ENQ                   0x05
#define ACK                   0x06
#define NAK                   0x15
#define ETB                   0x17
#define CAN                   0x18
#define ESC                   0x1B
#define SI                    0x1F
#define SO                    0x1E
#define START_CHAR            ENQ

/* Return Value */
#define RET_ACK                 50
#define RET_NAK                 60
#define RET_CAN                 70

/* Define Event */
enum Event{
     MENU_SELECT = 100,       /* MENU  event          */
     BARCODE_INPUT,     /* ڵ Է event        */
     SELECT_DATE,
     UPDATA_DATE,
     NON_UPDATA,
     INPUT_SABUN,
     QTY_INPUT,
     PASSWORD,
     UPDATE,
     SEARCH,
     NO_INPUT,
     NO_INPUT_1,
     NO_INPUT_2,
     NO_INPUT_3,
     DELETE,
     PASS_INPUT,
     RECEIVE_END,
     RECEIVE_FINISH,
     ERR_RECEIVE_CAN,
     TIMEOUT,
     START_STX,
     DATA_IN,
     DATE_INPUT,
     TIME_INPUT,
     JOB_SELECT

};
    /* Define Delay Time */
#define HALF_SECOND            50
#define ONE_SECOND            100
#define TWO_SECONDS           200

/* Kind of Font */
#define FONT_16_DOT   1
#define FONT_12_DOT   2


/* Null Pointer */
#define P_WNIL                            (WORD *)0
#define P_SNIL                            (ScreenFieldType *)0
#define P_MNIL                            (MenuType *)0

/* Define Error Code */
enum err_code{
  ERR_OK,
  ERR_PARAMETER,
  ERR_HANGUL_FONT,
  ERR_EXTERNAL_FONT,
  ERR_OBR_ALREADY_OPEN,
  ERR_SET_DATE,
  ERR_SET_TIME,
  ERR_COMM_OPEN,
  ERR_COMMUNICATION,
  ERR_COMM_ABORT,
  ERR_FILE_OPEN,
  ERR_FILE_READ,
  ERR_FILE_WRITE,
  ERR_FILE_SEEK,
  ERR_DATA_NOT_FOUND,
  ERR_DUPLICATION,
  SEARCH_DATA_NOT_FOUND,
  ERR_CHECK,
  ERR_INPUT,
  ERR_MEM_FULL,
  ERR_PASSWORD,
  ERR_SEARCH_DATA,
  ERR_FILE_FULL
};
typedef UB  BYTE;       /* unsigned 8-bit  integer, unsigned char  */
typedef UH      WORD;       /* unsigned 16-bit integer, unsigned short */
typedef UW      DWORD;      /* unsigned 32-bit integer, unsigned long  */

typedef struct {
        H               col;
        H               row;
        H               ankMode;
        H               attr;
        BYTE    *ps;
} ScreenFieldType;

typedef struct {
        int                                     (*func)();
        ScreenFieldType         screenField;
} MenuItemType;

typedef struct menu_struct {
        ScreenFieldType         *pTitle;
        MenuItemType            *pMenuItem;
        BYTE                            menuMax;
        struct menu_struct      *pMenuParent;
} MenuType;

#define  LEN_BEDAL_S_RECORD  sizeof(BeDalStartRecordType)
#define  peekw(o,s)  (*((int far*)(((long)(s) << 16) |(o))))
#define  TIMER_LO 0X46C
#define     _0_SEC_03   1
#define     _0_SEC_05   2
#define     _0_SEC_1    3
#define     _0_SEC_13   4
#define     _0_SEC_16   5
#define     _0_SEC_17   6
#define     _0_SEC_22   7
#define     _0_SEC_25   8
#define     _0_SEC_28   9
#define     _0_SEC_31   10
#define     _0_SEC_34   11
#define     _0_SEC_38   12
#define     _0_SEC_4    13
#define     _0_SEC_44   14
#define     _0_SEC_47   15
#define     _0_SEC_5    16
#define     _0_SEC_53   17
#define     _0_SEC_56   18
#define     _0_SEC_59   19
#define     _0_SEC_63   20
#define     _0_SEC_66   21
#define     _0_SEC_69   22
#define     _0_SEC_72   23
#define     _0_SEC_75   24
#define     _0_SEC_78   25
#define     _0_SEC_81   26
#define     _0_SEC_84   27
#define     _0_SEC_88   28
#define     _0_SEC_91   29
#define     _0_SEC_94   30
#define     _0_SEC_97   31
#define     _1_SEC_0    32
