#include <stdio.h>
#include <stddef.h>
#include <setjmp.h>
#include <stdlib.h>
#include <string.h>
#include "itron.h"
#include "cmndef.h"
#include "bios1mac.h"
#include <com_aplm.h>
#include "Header.h"

/* Declare System Related Variables */
M_TBL				obrModeTable;
DAT_PWR_STR 		powerMode;
DAT_KEY_STR 		keyMode;
DAT_OBR_STR 		obrMode;
DAT_DSP_STR 		displayMode;
DAT_TIM_STR 		buzzerMode;
DAT_SYS_STR 		machineId;
DAT_PRO_STR 		protocolControl;
CU_FILE_INFO_FORM	commFileInfo;
DAY_DAT 			dateCur;
TIM_DAT 			timeCur;
DAT_COM_STR 		commMode;
COM_STS 			com_sts;
DEL_TBL 			del_tbl;
TIM_TBL 			tim_tbl;


 /*  Key table	  */
 KEY_INPS			 key_str;			  /* key_string  */
 KEY_INPS			 key_strnum;		  /* key_num	 */
 KEY_INP			 key_chr;			  /* key_read	 */
/*  UW == DWORD == unsigned long  ( unsigned 32-bit integer )  */

/* Declare Buffers */
BYTE	keyBuffer[20+1] = "";
BYTE	barcodeBuffer[20+1] = "";
BYTE	displayBuffer[SCREEN_WIDTH_MAX+1] = "";
BYTE	workBuffer[SCREEN_WIDTH_MAX+1] = "";
BYTE	dateCharBuffer[LEN_DATE_CHAR+1];
BYTE	timeCharBuffer[LEN_TIME_CHAR+1];
BYTE	ReceiveRecord[100] = "";
/* OBR Variable */
DWORD	kindOfCode;
BYTE	lenOBR;


/* File Related Variables */
int 	FileNo;

/* Function Pointers */
int 	(*funcPostEvent)();
int 	(*funcClear)();
int 	(*funcError)();
/* Event Variable */
BYTE	Event;
int 	FileSize;
int 	RecordMax;
UW		ptn;
ID		fid,dumy;

/*	⺻  Լ */
void    HangulToJIS(BYTE *pSrc, BYTE *pDest );
void	ConvertStringHtoJ(BYTE	*pSrc, BYTE  *pDst);
void	MakeKeyAsEntConfirm();
void	MakeKeyAsMenuSelect(BYTE event);
void	KeyNumerInputOn(UH dx, UH dy, BYTE event, UH len);
void	KeyNumerInputOff(UH dx, UH dy, BYTE event, UH len);
void	MakeKeyAsOBR(UH dx, UH dy, BYTE event, UH len );
void	Delay(int delay);
void	OpenOBR();
void	CloseOBR();
void	GetBarcodeData();
void	DisplayErrorMessage(int errNo);
void	DisplayScreen(ScreenFieldType *pScreenField);
void	DisplayScreen2(ScreenFieldType *pScreenField);
void	DisplayScreenField(ScreenFieldType	*pScreenField);
void	Beep();
int 	Wait_ch(unsigned int tsecs);
int 	DoLowBatteryTreatment();
int 	SelectMenu();
void	DisplayMenu();

/*  ΰ ÷ Լ  */
int     DisplayLogo();

/*   ʱȭ Լ    */
 void Init_Start();
 void Init_SYS();
 void Init_KEY();
 void Init_VAR();
 int  Init_OBR();
 int  Init_HANGUL(int flag);
 void Init_KeyCode();


/*************************************/
/**    ۾  ȭ(Main Menu)	**/
/*************************************/
int 	MainStartMenu();

/* Function Key Control */

void	FuncKeySet(int funcnum);
void	FuncKeyClear(int funcnum);

/*	¥, ð Է Լ  */
int 	DateTime();
int 	SetupDateIn();
int 	SetDateAndSetupTimeIn();
int 	SetTimeAndSetupDateTime();
int 	SetDateFromKeyBuffer();
int 	SetTimeFromKeyBuffer();
int 	GetDateTime();
/* menu*/
int IBGOMENU();
int CHULMENU();
int JAEMENU();
int JOHMENU();

/*	1. Է  */
int 	InputFunt();
int 	InputFunt_2();
int 	InputSaveFunt();
int 	QtyCheck();
int     MasterCheck();

/* 2. ȸ  */
int     searchdata(); 
int     SearchMenu_2();

/*	4.    */
int 	DeleteFunt();
int     DeleteConfirm();
int 	Delete();

/*  3.    */
int 	SongSinFunt();
int     SusinFunt();
int     SongSinConfirm();
int     FileReceive();
int 	FileSend();
int 	AckNakChk();
int 	PortOpen();
int 	SendFirstChk();

BYTE    SendData[1048] = "";
B       RcvBuffer[1048] = "";
B		OneRcv;

BYTE    QtyData[6] = "";
BYTE    qty[6] ="";
BYTE    Barcode[25] = "";
BYTE	CountData[6] = "";
BYTE    Pummyung[19] = "";
BYTE    Pummyung1[17] = "";
BYTE    Pummyung2[17] = "";
BYTE    myung[2]="";
BYTE    MYung[15]="";
BYTE    pumm[17] = "";
BYTE    FileName[13];

int  gubun=0;


/* Declare Error Messages */
BYTE	*errorMessage[] = {
	"Ű  !",      /* ERR_PARAMETER        */
	"ѱ Ʈ  !",     /* ERR_HANGUL_FONT      */
	"Ext. font error!",     /* ERR_EXTERNAL_FONT    */
	"OBR already open",     /* ERR_OBR_ALREADY_OPEN */
	" ¥ Է  ",     /* ERR_SET_DATE         */
	" ð Է  ",     /* ERR_SET_TIME         */
	"Ʈ¿",     /* ERR_COMM_OPEN        */
	"  ",     /* ERR_COMMUNICATION    */
	"  ",     /* ERR_COMM_ABORT       */
	"   !",     /* ERR_FILE_OPEN        */
	" б  !",     /* ERR_FILE_READ        */
	"   !",     /* ERR_FILE_WRITE       */
	" ã  !",     /* ERR_FILE_SEEK        */
	" Ÿ ",     /* ERR_DATA_NOT_FOUND   */
	"̹ Է   ",     /* ERR_DUPLICATION      */
	"ã Ÿ ",     /* SEARCH_DATA_NOT_FOUND   */
	"   Է ",     /*     ERR_CHECK      */
	"Է  Ʋ",     /*     ERR_INPUT      */
	"޸𸮰  ",     /*     ERR_MEM_FULL   */
	"ȣ Ʋϴ.",     /*  ERR_PASSWORD      */
	"ã Ÿ ",      /* ERR_SEARCH_DATA   */
    "մϴ",      /* ERR_FILE_FULL     */
	""
};

BYTE MyCheck[16];
ScreenFieldType   MsgCheck[] = {			   /*0123456789012345*/
	{ 0, 4, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, MyCheck },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""           }
};
/*	Define Full Screen Messages  */
/*	1.   ȭ 	*/
ScreenFieldType   MsgLogo[] = { 			  /*0123456789012345*/
    { 0, 4, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "     ICOM      " },
/*	{ 0, 5, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "   ý   " }, */
    { 0, 7, LCD_ANK_LIGHT   , LCD_ATTR_NORMAL, "         Ver 1.0" },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""           }
};

ScreenFieldType searchLogo[] = {               /*0123456789012345*/
	{  0, 1, LCD_ANK_STANDARD, LCD_ATTR_REVERS, "----   ȸ-----"},
	{  0, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "ڵ:[________"},
    {  0, 5, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "__________]"},
    { 8, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, Pummyung1         },
    { 0, 5, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, Pummyung2         },
    { 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "[____]"},
    { 5, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, QtyData           },
    { 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""           }
};

ScreenFieldType searchresult = {
	 5, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, QtyData
};

ScreenFieldType   InputInput[] = {            /*0123456789012345*/
    { 0, 1, LCD_ANK_STANDARD, LCD_ATTR_REVERS, "----    ----"},
    { 0, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "ڵ:[_     __"},
    { 0, 5, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "__________]     "},
    { 8, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, Pummyung1         },
    { 0, 5, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, Pummyung2         },
    { 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "[____]<    >"},
    { 5, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, QtyData           },
    {11, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, CountData         },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""           }
};

ScreenFieldType   MsgFileDelete[] = {		  /*0123456789012345*/
	{ 0, 1, LCD_ANK_STANDARD, LCD_ATTR_REVERS, "<<ȭ    >>" },
	{ 0, 4, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, " Ȯ    : ENT  " },
    { 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "     : CLR  " },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""           }
};

ScreenFieldType   MsgOkDelete = {			 /*0123456789012345*/
	 0, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "      !!"
};

/*	2. ۾ ȭ ( Main Menu )	*/
ScreenFieldType   MainTitle = { 			  /*0123456789012345*/
	  0, 1, LCD_ANK_STANDARD, LCD_ATTR_REVERS, "<<<۾  >>>"
};

ScreenFieldType   subTitle = { 			  /*0123456789012345*/
	  0, 1, LCD_ANK_STANDARD, LCD_ATTR_REVERS, "<<<۾  >>>"
};

MenuItemType	  subMenuItems[] = {                         /*123456789012345*/
   { InputFunt  , { 0, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, " 1.Է    " } },
   { searchdata , { 8, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, " 2.ȸ    " } },
   { SongSinFunt, { 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, " 3.    " } },
   { DeleteFunt,  { 8, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, " 4.    " } }
};

MenuType   subMenu =  { &subTitle,  subMenuItems,  4, P_MNIL };

MenuItemType   MainMenuItems[] = {						/*0123456789012345*/
   { IBGOMENU,    { 0,3,LCD_ANK_STANDARD,LCD_ATTR_NORMAL, "1.         "}},
   { CHULMENU   , { 0,5,LCD_ANK_STANDARD,LCD_ATTR_NORMAL, "2.         "}}, 
   { JAEMENU    , { 0,7,LCD_ANK_STANDARD,LCD_ATTR_NORMAL, "3.         "}}, 

};

MenuType   MainMenu =  { &MainTitle,  MainMenuItems,  3, P_MNIL };
MenuType   *pMenuCur;

ScreenFieldType   ExeFileSend[] = {
	{ 0, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL,	"          " },
	{ 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL,	" ٸ!" },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""            }
};
ScreenFieldType   ExeFileReceive[] = {
    { 0, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL,  "          " },
	{ 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL,	" ٸ!" },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""            }
};
ScreenFieldType   MsgSendOver[] = {
	{ 0, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL,	"        " },
	{ 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL,	"ENT  !" },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""            }
};
ScreenFieldType   MsgReceiveOver[] = {
    { 0, 3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL,  "        " },
	{ 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL,	"ENT  !" },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""            }
};
ScreenFieldType   MsgFileSend[] = {
	{ 0, 1, LCD_ANK_STANDARD, LCD_ATTR_REVERS, "<<ȭ    >>" },
	{ 0, 4, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, " Ȯ    : ENT  " },
    { 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "     : CLR  " },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""           }
};
ScreenFieldType   MsgFileReceive[] = {
    { 0, 1, LCD_ANK_STANDARD, LCD_ATTR_REVERS, "<<ȭ    >>" },
	{ 0, 4, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, " Ȯ    : ENT  " },
    { 0, 7, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, "     : CLR  " },
	{ 0xff, 0xff, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, ""           }
};

ScreenFieldType   BarcodeMsg2[] = {
	 0,5, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, MYung
};
ScreenFieldType   BarcodeMsg[] = {
	13,3, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, myung
};

ScreenFieldType   LowBattery = {
	  0, 3, LCD_ANK_STANDARD, LCD_ATTR_REVERS, "嵥 ü "
};
ScreenFieldType   MsgWork = {
	  0, 5, LCD_ANK_STANDARD, LCD_ATTR_NORMAL, workBuffer
};

/*	α׷   */
void	ap_start()
{
	FILE *fp;
	long point;
	int 	errorReturn, lenString, ret, cmpRet,i,sum;
	BYTE	TempBarcode[LEN_BARCODE+1] = "",Buffer[55];
    BYTE    Buff[2] = "",buffer[8]="",temp[7] = "",temp_2[7] = "";
	ER		err, eventResult,ercd;

/******************************************************************************/
/************************* DT 900 ʱȭ    *******************************/
/******************************************************************************/
	 Init_Start();
	 errorReturn = Init_OBR();
	 if( errorReturn != ERR_OK ) {
		 DisplayErrorMessage(errorReturn);
	 }

	 errorReturn = Init_HANGUL(FONT_16_DOT); /* FONT_16_DOT : 16*16ѱƮ  */
										/* FONT_12_DOT : 12*12ѱƮ  */
	 if( errorReturn != ERR_OK ) {
		 DisplayErrorMessage(errorReturn);
	 }
/******************************************************************************/
/************************* DT 900 ʱȭ    *******************************/
/******************************************************************************/
    DisplayLogo();

	while(1) {
        sum = 0 ;
		key_clear();
		FuncKeySet(1);
		errorReturn = ERR_OK;
        eventResult = key_string( &key_str, keyBuffer );
		lenString = strlen((char *)keyBuffer);
		switch( eventResult ) {
			case	E_OK:
				switch(Event) {
					case	QTY_INPUT:
                            if(lenString == 0){
                                sprintf((char *)QtyData,"  1");
                            }
                            else {
                                sprintf((char *)QtyData,"%4d" , atoi((char *)keyBuffer));
                            }
                            errorReturn = (*funcPostEvent)();
							break;
					case	NO_INPUT:
							errorReturn = (*funcPostEvent)();
							break;
					case	BARCODE_INPUT:
						CloseOBR();
                        if(lenString == 18) {
                                sprintf((char *)Barcode,"%18.18s",keyBuffer);
                                errorReturn = (*funcPostEvent)();
						} else
							errorReturn = ERR_INPUT;
						break;
				 }
				 break;
			 case	 E_KEY_OBR :
				GetBarcodeData();
				if(Event == BARCODE_INPUT){
                   if(lenOBR == 18) {
                            sprintf((char *)Barcode,"%18.18s",barcodeBuffer);
                        /*    MasterCheck(); */
                            errorReturn = (*funcPostEvent)();
                   }
                   else
						errorReturn = ERR_INPUT;
                   break;
				}
				break;
            case    E_KEY_CLR:
                   CloseOBR();
                   errorReturn = (*funcClear)();
                   break;
				break;
		  case	  E_KEY_FUL:

                 if ( Event == MENU_SELECT ) {
				  if ( (keyBuffer[0] >= '1') && ( ( keyBuffer[0] - '0') <= pMenuCur->menuMax ) )
						errorReturn = SelectMenu();
				  else 
					   errorReturn = (*funcError)();
					break;
				}
                break;

		case	E_KEY_LB:
				errorReturn = DoLowBatteryTreatment();
				break;
		case	E_PRM:
                Init_KEY();
                errorReturn = (*funcError)();
				break;
	 }
	if( errorReturn != ERR_OK ) {
				s_beep();
				Delay(10);
				s_sound( 2700, 30 );
				Delay(20);
				DisplayErrorMessage( errorReturn );
				(*funcError)();
	}
  }

}

DisplayLogo()
{
	ER	 key,ercd;
	UW	 size;
	lcd_csr_set(LCD_CSR_OFF);
	DisplayScreen(MsgLogo);

    key_str.ext  = KEY_LB_EXT | KEY_FULL_CHR;
    key_str.echo = ECHO_OFF;
    key_str.len = 1;
	keyBuffer[0] = 0x00;
	key_clear();
    key = key_string( &key_str, keyBuffer );
	return MainStartMenu();
}

GetDateTime()
{
	ER		ret;

	if ( ( ret = s_dateget( &dateCur ) ) != E_OK )
		return	ERR_PARAMETER;
	if ( ( ret = s_timeget( &timeCur ) ) != E_OK )
		return	ERR_PARAMETER;
	return	ERR_OK;
}

/**************************************************************************/
/***************************  Main Menu    ********************************/
/**************************************************************************/
MainStartMenu()
{
	keyBuffer[0] = 0x00;
	pMenuCur = &MainMenu;
	DisplayMenu();

	MakeKeyAsMenuSelect(MENU_SELECT);
	funcClear =  DisplayLogo;
	funcError =  MainStartMenu;
	return	ERR_OK;

}

CHULMENU()
{
	keyBuffer[0] = 0x00;
	pMenuCur = &subMenu;
	DisplayMenu();
	gubun = 2;
	MakeKeyAsMenuSelect(MENU_SELECT); 
	funcClear =  MainStartMenu;
	funcError =  CHULMENU;
	return	ERR_OK;
}

IBGOMENU()
{
	keyBuffer[0] = 0x00;
	pMenuCur = &subMenu;
	gubun = 1;
	DisplayMenu();
	MakeKeyAsMenuSelect(MENU_SELECT); 
	funcClear =  MainStartMenu;
	funcError =  IBGOMENU;
	return	ERR_OK;
}

JAEMENU()
{
	keyBuffer[0] = 0x00;
	pMenuCur = &subMenu;
	gubun = 3;
	DisplayMenu();
	MakeKeyAsMenuSelect(MENU_SELECT); 
	funcClear =  MainStartMenu;
	funcError =  JAEMENU;
	return	ERR_OK;
}

InputFunt()
{
    keyBuffer[0] = 0x00;
    Barcode[0] = 0x00;
    Pummyung[0] = 0x00;
	myung[0]=0x00;
	MYung[0]=0x00;
    QtyData[0] = 0x00;
	sprintf(FileName,"IOSEL%1.1d.DAT",gubun);
    MakeKeyAsOBR(8,3, BARCODE_INPUT, 18);
    OpenOBR();
    sprintf((char *)CountData,"%4d",QtyCheck());
	DisplayScreen(InputInput);
    funcPostEvent = InputFunt_2;
    if(gubun == 1)
		funcClear = IBGOMENU;
	else if(gubun == 2)
		funcClear = CHULMENU;
	else
		funcClear = JAEMENU;
    funcError = InputFunt;
	return	ERR_OK;
}
InputFunt_2()
{
    long point;
 	ER	ercd;

	BYTE  Buff[50] = "",Buffer[25]="";
	FILE *fp;
	int i;
    QtyData[0] = 0x00;
    keyBuffer[0] = 0x00;

    
	fp = fopen(FileName,"a+b");
	if(fp == NULL)
		return ERR_FILE_OPEN;

    ercd = dat_F_Search(FileName, 0, 24,0, 18, Barcode, Buff, &point);
	if( ercd == E_OK){
		fclose(fp);
        return ERR_DUPLICATION;
	}
	fclose(fp);

	sprintf(Pummyung1,"%8.8s",Barcode);
	sprintf(Pummyung2,"%10.10s",Barcode+8);
	sprintf(Pummyung,"%18.18s",Barcode);

	DisplayScreen(InputInput);
    MakeKeyAsOBR(5, 7, QTY_INPUT, 4 );

    funcPostEvent = InputSaveFunt;
    funcClear =  InputFunt;
	funcError =  InputFunt_2;
	
	return	ERR_OK;
}
InputSaveFunt()
{
	ER ret,ercd;
	FILE *fp;
	BYTE  Buffer[18]="";
    BYTE  Buff[50]="";
	int memory;
	long point;
    memory=dat_fsize();
	if (memory <( 55*50 ))
        return ERR_MEM_FULL;

    fp = fopen(FileName,"a+b");
	if(fp == NULL)
		return ERR_FILE_OPEN;

    sprintf((char *)Buff,"%18.18s%4.4s%c%c",(char *)Barcode,(char *)QtyData,0x0d,0x0a);
	fseek(fp,0L,SEEK_END);
    fwrite((char *)Buff,strlen((char *)Buff),1,fp);
	fclose(fp);
    s_beep();
    return InputFunt();
}

/***********  ȸ *****************/

searchdata()
{
	keyBuffer[0] = 0x00;
	sprintf((char*)keyBuffer,"%s",Pummyung);
	Barcode[0] =  0x00;
	pumm[0] = 0x00;
    MakeKeyAsOBR(8,3, BARCODE_INPUT, 18);
	OpenOBR();
	DisplayScreen(searchLogo);	

	funcPostEvent = SearchMenu_2;
	funcError = searchdata;

    if(gubun == 1)
		funcClear = IBGOMENU;
	else if(gubun == 2)
		funcClear = CHULMENU;
	else
		funcClear = JAEMENU;

	return	ERR_OK;
}

SearchMenu_2()
{
	FILE *fp;
	long seekpoint = 0,point;

	ER	ercd;
    BYTE  Buff[50] = "",Buffer[25]="";

	lcd_csr_set(LCD_CSR_OFF);
	sprintf(FileName,"IOSEL%1.1d.DAT",gubun);
	
	fp = fopen(FileName,"rb");
	if(fp == NULL)
       return ERR_FILE_OPEN;
    
	ercd = dat_F_Search(FileName, 0, 24,0, 18, Barcode, Buff, &point);
	if( ercd != E_OK){
		fclose(fp);         /*0123456789012345*/
		return SEARCH_DATA_NOT_FOUND; 
	}
	else {
		fclose(fp);         /*0123456789012345*/
        sprintf((char *)QtyData,"%4.4s",(char *)Buff+18);
	}
	sprintf(Pummyung1,"%8.8s",Barcode);
	sprintf(Pummyung2,"%10.10s",Barcode+8);
	sprintf(Pummyung,"%18.18s",Barcode);

	DisplayScreenField(&searchresult);
	return searchdata();
}

DeleteFunt()
{
    DisplayScreen(MsgFileDelete);
    KeyNumerInputOff(9, 0, NO_INPUT, 1);
	funcPostEvent = Delete;
    funcClear = MainStartMenu;
	funcError = MainStartMenu;
	return	ERR_OK;
}
Delete()
{
	sprintf(FileName,"IOSEL%1.1d.Dat",gubun);
    dat_fdel(FileName);
    lcd_cls();
    s_sound( 3000, 20 );
    Delay(20);
    DisplayScreenField(&MsgOkDelete);
    Delay(100);
    return  MainStartMenu();
}

QtyCheck()
{
	FILE *fp;
	long seekpoint = 0,point;
	int i,count= 0,total;
	BYTE  Buffer[LEN_DATA_RECORD + 1]="";
	ER	ercd;
      if((fp = fopen(FileName, "a+b" )) == NULL ){
		  return 0;
      }
	fseek(fp, 0L, SEEK_END);
    FileSize = ftell(fp) / 24;
	if(FileSize == 0 ){
		fclose(fp);
		return 0;
	}
	fclose(fp);
	return FileSize;
}

void FuncKeySet(int funcnum)
{
	fid = FL_FK_INT_ID;
	switch(funcnum)
	{
	case 2:
		ptn = FL_FK_INT_FNC2;
			key_fnc_mode(FNC_MODE_SET,FNC_2, &fid,&ptn);
			break;
	case 3:
			ptn = FL_FK_INT_FNC3;
			key_fnc_mode(FNC_MODE_SET,FNC_3, &fid,&ptn);
		break;
	case 1:
		ptn = FL_FK_INT_FNC1;
		key_fnc_mode(FNC_MODE_SET,FNC_1, &fid,&ptn);
		break;
	case 5:
		ptn = FL_FK_INT_FNC5;
		key_fnc_mode(FNC_MODE_SET,FNC_5, &fid,&ptn);
			break;

	case 4:
		ptn = FL_FK_INT_FNC4;
		key_fnc_mode(FNC_MODE_SET,FNC_4, &fid,&ptn);
			break;
	case 6:
		ptn = FL_FK_INT_FNC6;
		key_fnc_mode(FNC_MODE_SET,FNC_6, &fid,&ptn);
		break;
	case 7:
		ptn = FL_FK_INT_FNC7;
		key_fnc_mode(FNC_MODE_SET,FNC_7, &fid,&ptn);
			break;
	}
}

void FuncKeyClear(int funcnum)
{
	fid = FL_FK_INT_ID;
	switch(funcnum)
	{
	case 2:
			ptn = FL_FK_INT_FNC2;
			key_fnc_mode(FNC_MODE_CLR,FNC_2, &fid,&ptn);
			break;
	case 3:
			ptn = FL_FK_INT_FNC3;
			key_fnc_mode(FNC_MODE_CLR,FNC_3, &fid,&ptn);
			break;
	case 1:
		ptn = FL_FK_INT_FNC1;
		key_fnc_mode(FNC_MODE_CLR,FNC_1, &fid,&ptn);
			break;
	case 5:
		ptn = FL_FK_INT_FNC5;
		key_fnc_mode(FNC_MODE_CLR,FNC_5, &fid,&ptn);
			break;

	case 4:
		ptn = FL_FK_INT_FNC4;
		key_fnc_mode(FNC_MODE_CLR,FNC_4, &fid,&ptn);
			break;
	case 6:
		ptn = FL_FK_INT_FNC6;
		key_fnc_mode(FNC_MODE_CLR,FNC_6, &fid,&ptn);
			break;
	case 7:
		ptn = FL_FK_INT_FNC7;
		key_fnc_mode(FNC_MODE_CLR,FNC_7, &fid,&ptn);
			break;
	}
}

SongSinFunt()
{
    DisplayScreen(MsgFileSend);
	MakeKeyAsEntConfirm();
	funcPostEvent = FileSend;
	funcError = MainStartMenu;

    if(gubun == 1)
		funcClear = IBGOMENU;
	else if(gubun == 2)
		funcClear = CHULMENU;
	else
		funcClear = JAEMENU;
	return	ERR_OK;
}



/******************************************************************************/
/************************* DT 900 ڷ  , ****************************/
/******************************************************************************/
FileSend()
{
    int     k, ret, RcvDataLen, AckNakRec,NakCount =0,len;
    long    i, size, TotRecCount ,RecCount, seekpoint,Remaind;
    BYTE    SndBuffer[50] = "";
    char    RecData[10] = "";
	ER		sysRet;
	FILE *fp;
	
	
	lcd_csr_set(LCD_CSR_OFF);

	sprintf(FileName,"IOSEL%1.1d.DAT",gubun);
    fp = fopen(FileName,"a+b");
    fseek(fp,0L,SEEK_END);
    RecordMax = ftell(fp);
    TotRecCount = RecordMax / LEN_DATA_RECORD;
	fclose(fp);
	if( RecordMax == 0 ) {
        return ERR_DATA_NOT_FOUND;
	}

	/************  PortOpen Routine  **********/
	if( (ret = PortOpen()) != ERR_OK ) {
		return ret;
	}
    DisplayScreen(ExeFileSend);

	/***  First Data  Send Routien	**/
	while(1) {
		ret = FirstChk();
		if( ret == ERR_OK ) {
			break;
		}
		else {
           c_close(COM0);
		   return ret;
		}
	}
	while(1){
		if(NakCount >= 10 ){
			c_close(COM0);
			return ERR_COMMUNICATION;
		}
        sprintf((char *)SendData,"%c%d%03d%05d%c",SOH,gubun,LEN_DATA_RECORD,TotRecCount,ETX);
		c_iobox(COM0, C_IOBOXENB);
        for(i=0; i<strlen((char *)SendData); i++ ) {
			c_out(COM0, SendData[i] );
		}
		ret = StxDataEtxChk(20);
		if(ret == ERR_RECEIVE_CAN){
		   c_close(COM0);
		   return ERR_COMMUNICATION;
		}
        if(ret == RECEIVE_END && strlen((char *)ReceiveRecord) == 1){
		   if(ReceiveRecord[0] == ACK)
			 break;
		   else if(ReceiveRecord[0] == NAK)
			  NakCount++;
		}
		else{
			c_close(COM0);
		   return ret;
		}
	}
    RecCount = 1;
	NakCount = 0;
	AckNakRec = 0;

	sprintf(FileName,"IOSEL%1.1d.DAT",gubun);
	
	fp = fopen(FileName,"a+b");
    DisplayScreen(ExeFileSend);
	
	while(1){
        if(RecCount > TotRecCount){
           memset(SendData,' ',100);
           sprintf((char *)SendData,"%c%28.28s%c",EOT,0,ETX);
		   c_iobox(COM0, C_IOBOXENB);
           c_dout(COM0,(char *)SendData,strlen((char *)SendData));
		   break;
		}
		if(NakCount >= 10 ){
			c_close(COM0);
			return ERR_COMMUNICATION;
		}
		
		seekpoint = (RecCount-1)*LEN_DATA_RECORD;
            
		fseek(fp, seekpoint, SEEK_SET);
    
		fread((char *)SndBuffer,24,1,fp);
	
		
		sprintf( (char *)SendData, "%c%04d%s%c", STX,RecCount,SndBuffer, ETX );
        sprintf((char *)workBuffer, "     [%4d ]   ",RecCount);  
	
		MsgWork.col = 0;
		MsgWork.row = 5;
		DisplayScreenField(&MsgWork);
		
		c_iobox(COM0, C_IOBOXENB);
        c_dout(COM0,(char *)SendData,strlen((char *)SendData));
		ret = StxDataEtxChk(20);
		if(ret == ERR_RECEIVE_CAN){
		   c_close(COM0);
   		   fclose(fp);
		   return ERR_COMMUNICATION;
		}
        if(ret == RECEIVE_END && strlen((char *)ReceiveRecord) == 1){
		   if(ReceiveRecord[0] == ACK)
			 RecCount++;
		   else if(ReceiveRecord[0] == NAK)
			 NakCount++;
		}
		else{
		   c_close(COM0);
		   fclose(fp);
           return ret;
		}

	}
    fclose(fp);
    ret = StxDataEtxChk(20);
    if(ret == ERR_RECEIVE_CAN){
       c_close(COM0);
       return ERR_COMMUNICATION;
    }
    if(ret != RECEIVE_END || ReceiveRecord[0] != ACK){
       c_close(COM0);
       return ERR_COMMUNICATION;
    }
    sprintf((char *)workBuffer, "     [%4d ]   ",RecCount);
	Delay(10);
	c_close(COM0);
	Beep(1);
	key_clear();			/* clear key input */
	keyBuffer[0] = 0x00;
    DisplayScreen(MsgSendOver);

    key_str.ext  = KEY_LB_EXT|KEY_CLR_EXT;
    key_str.echo = ECHO_OFF;
    key_str.len = 1;
    sysRet = key_string( &key_str, keyBuffer );
	
	if( sysRet == E_OK ) {
		if(gubun == 1)
			funcClear = IBGOMENU;
		else if(gubun == 2)
			funcClear = CHULMENU;
		else
			funcClear = JAEMENU;
	}
    if(gubun == 1)
		funcClear = IBGOMENU;
	else if(gubun == 2)
		funcClear = CHULMENU;
	else
		funcClear = JAEMENU;
		
	return (*funcClear)();
}

/******************************************************************************/
/************************* DT 900 ڷ  , **************************/
/******************************************************************************/



/******************************************************************************/
/************************* DT 900 SERIAL Ʈ *************************/
/******************************************************************************/

PortOpen()
{
	B		  xon, xoff;
	ER		  sysRet;
	UW		  SetComm;

    tim_tbl.cs = 0;
    tim_tbl.dr = 0;
    tim_tbl.cd = 0;

	xon  = 17;
	xoff = 19;
	SetComm = B_19200 | PARI_NON | CHAR_8 | STOP_1 | RTS_OFF | ER_OFF | SI_OFF | BUSY_OFF;
    sysRet  = c_open(COM0, SetComm, (char*)RcvBuffer,(int)1048, &tim_tbl, &del_tbl, xoff, xon );
	if( sysRet != E_OK ) {
		c_close(COM0);
		return	ERR_COMM_OPEN;
	}
	c_chghdr(COM0, HIGH_HDR);
	c_flush(COM0);
	c_txrx(COM0, C_RXTXENB);
	return ERR_OK;
}
FirstChk()
{
	int 	i, ret;

	i = 0;
    c_iobox(COM0, C_IOBOXDSB);
	while(i < 20){
        ret = Wait_ch(_1_SEC_0);
		if( key_check() != E_NG ) {
			key_clear();
			return ERR_COMM_ABORT;
		}
		if( ret == TIMEOUT ) {
			 i++;
			 continue;
		}
		else if(OneRcv == ENQ){
			  return ERR_OK;
		}
		else if(OneRcv == CAN){
			return ERR_COMMUNICATION;
		}
	}
	return ERR_COMMUNICATION;
}

StxDataEtxChk(int waitSec)
{
	int    hd, ret, state,ercd;
	hd = 0;
	state = START_STX;
	c_iobox(COM0, C_IOBOXDSB);
    if( waitSec == 0 ) {
        return ERR_COMMUNICATION;
    }
   c_iobox(COM0,C_IOBOXDSB);

    while(state != RECEIVE_END) {
        ret = Wait_ch(_1_SEC_0 * waitSec);
        if( ret == TIMEOUT ) {
             return ERR_COMMUNICATION;
		}
		if( OneRcv == CAN) return ERR_COMMUNICATION;
		switch( state ) {
		   case START_STX :
                if( OneRcv == STX  || OneRcv == SOH || OneRcv == EOT) {
					state = DATA_IN;
                    if(OneRcv == EOT)
                        return RECEIVE_FINISH;
                    memset( (char *)ReceiveRecord, '\0', 1040 );
				}
				break;
		   case DATA_IN   :
				if( OneRcv == ETX ) {
					c_flush(COM0);
					state = RECEIVE_END;
				} else {
                    *(ReceiveRecord+hd) = OneRcv;
					hd++;
				}
				break;
		}
	}
}
int Wait_ch(unsigned int tsecs)
{
	int 		tcount;
	UW			ptn;
	ID			fid, dumy;
	ER			sysRet, timer_id;

	tcount = 0;
	timer_id = s_settimer2(FL_TM2_INT_ID, FL_TM2_INT_ITU0, tsecs);
	while(tsecs) {
		sysRet = c_bfsts(COM0, &com_sts);
        if(com_sts.char_no > 0) {
           c_din(COM0, &OneRcv);
		   s_timerend2(timer_id);
		   return ERR_OK;
		}
		sysRet = flg_sts(&dumy, &ptn, FL_TM2_INT_ID);
		if(ptn & FL_TM2_INT_ITU0) {
			tsecs=0;
			clr_flg(FL_TM2_INT_ID,~FL_TM2_INT_ITU0);
		}
	}
	s_timerend2(timer_id);
	return TIMEOUT;
}
/******************************************************************************/
/************************* DT 900 SERIAL Ʈ     ***********************/
/******************************************************************************/

void	MakeKeyAsEntConfirm()
{
    key_str.ext = KEY_LB_EXT | KEY_FULL_CHR| KEY_CLR_EXT;
    key_str.echo = ECHO_OFF;
    key_str.len = 1;
	keyBuffer[0] = 0;
    key_str.column_len = 0;
	Event = NO_INPUT;
	lcd_csr_set(LCD_CSR_OFF);
}
void	MakeKeyAsMenuSelect(BYTE event)
{
    key_str.ext = KEY_LB_EXT | KEY_FULL_CHR | KEY_CLR_EXT;
    key_str.echo = ECHO_OFF;
    key_str.len = 1;
	Event = event;
	lcd_csr_set(LCD_CSR_OFF);
}
void	KeyNumerInputOn(UH dx, UH dy, BYTE event, UH len)
{
    key_str.ext = KEY_LB_EXT | KEY_CLR_EXT;
    key_str.echo = ECHO_ON;
    key_str.len = len;
    key_str.column_pos = dx;
    key_str.line_pos = dy;
	Event = event;
    key_str.column_len = 0;
	lcd_csr_set(LCD_CSR_BLOCK);
}
void	KeyNumerInputOff(UH dx, UH dy, BYTE event, UH len)
{
    key_str.ext = KEY_LB_EXT | KEY_FULL_CHR| KEY_CLR_EXT;
    key_str.echo = ECHO_OFF;
    key_str.len = len;
    key_str.column_pos = dx;
    key_str.line_pos = dy;
	Event = event;
    key_str.column_len = 0;
	lcd_csr_set(LCD_CSR_OFF);
}
void	MakeKeyAsOBR(UH dx, UH dy, BYTE event, UH len )
{
    key_str.ext = KEY_LB_EXT | KEY_OBR_EXT| KEY_CLR_EXT;
    key_str.echo = ECHO_ON;
    key_str.len = len;
    key_str.column_pos = dx;
    key_str.line_pos = dy;
	Event = event;
    key_str.column_len = 0;
	lcd_csr_set(LCD_CSR_BLOCK);
}
void	Delay(int delay)
{
	long delayTime;

	for(delayTime = 0; delayTime < delay * 100; delayTime++);
}
void  Beep()
{
	int i;

	Delay(50);
	s_beep();
	s_sound( 3000, 20 );
	s_beep();
	s_sound( 3000, 20 );
}
void	OpenOBR()
{
	lenOBR = 0;
	OBR_open(0);
	OBR_flush();
}
void	CloseOBR()
{
	OBR_flush();
	OBR_close();
}
void	GetBarcodeData()
{
	memset(barcodeBuffer, ' ', LEN_BARCODE);
	barcodeBuffer[18] = 0x00;
	lenOBR = 0;
	kindOfCode = 0;
    OBR_gets(barcodeBuffer, &kindOfCode, &lenOBR);
	CloseOBR();
	if( lenOBR ) {
		lenOBR--;
		barcodeBuffer[lenOBR] = '\0';        /* replace CR with 0 */
	}
}
DoLowBatteryTreatment()
{
	int   i;
	ER	  key;

	lcd_cls();
	keyBuffer[0] = 0;
	key_clear();
	DisplayScreenField(&LowBattery);
	for( i=0; i<5; i++ ) {
		s_sound(3000, 5);
		Delay(40);
	}
    key_str.ext  = KEY_LB_EXT;
    key_str.echo = ECHO_OFF;
    key_str.len = 1;
    key = key_string( &key_str, keyBuffer );
	if( key == E_OK ) {
		return	ERR_OK;
	}
	return	ERR_OK;
}



/**************************************************************************/
/**********************    DisplayԼ  ()   ********************/
/**************************************************************************/
SelectMenu()
{
	WORD			menuIndex;
	MenuItemType	*pMenuItem;

	menuIndex = keyBuffer[0] - '1';
	pMenuItem = pMenuCur->pMenuItem + menuIndex;
	return	(*pMenuItem->func)();
}
void	DisplayErrorMessage(int errNo)
{
	if ( errNo ) {
		lcd_cls();
		lcd_csr_set(LCD_CSR_OFF);
		lcd_csr_put(3,0);
		ConvertStringHtoJ(errorMessage[errNo-1], displayBuffer);
		lcd_string(LCD_ANK_STANDARD, LCD_ATTR_NORMAL, displayBuffer, LCD_LF_OFF);
		Delay(120);
	}
}
void	DisplayMenu()
{
	BYTE			i;
	MenuItemType	*pItem;

	lcd_cls();
	if ( pMenuCur->pTitle != P_SNIL )
		DisplayScreenField(pMenuCur->pTitle);

	for(i=0, pItem = pMenuCur->pMenuItem; i < pMenuCur->menuMax; i++, pItem++ )
		DisplayScreenField(&pItem->screenField);
}

void	DisplayScreen(pScreenField)
ScreenFieldType *pScreenField;
{
	lcd_cls();
	while( pScreenField->col != 0xff )
		DisplayScreenField(pScreenField++);
}
void	DisplayScreen2(pScreenField)
ScreenFieldType *pScreenField;
{
	while( pScreenField->col != 0xff )
		DisplayScreenField(pScreenField++);
}

void	DisplayScreenField(pScreenField)
ScreenFieldType *pScreenField;
{
	lcd_csr_put(pScreenField->row, pScreenField->col);
	ConvertStringHtoJ(pScreenField->ps, displayBuffer);
	lcd_string(pScreenField->ankMode, pScreenField->attr, displayBuffer, LCD_LF_OFF);
}
/**************************************************************************/
/**********************    DisplayԼ   ()    ********************/
/**************************************************************************/


/* Convert one KSC Hangul code to JIS code */
void HangulToJIS( pSrc, pDest )
BYTE   *pSrc;			  /* String pointer for source		*/
BYTE   *pDest;			  /* String pointer for destination */
{
	 UB   High, Low;
	 UH   noOfCharacter;

	 /* High:ѱڵ ù° پƮ,  Low:ѱڵ ι° پƮ */
	 High = *pSrc;
	 Low  = *(pSrc + 1);

	 if( ( High >= 0xb0 ) && ( Low >= 0xa1 ) ) {
		 /* ѱ ġ,  94= (0xfe-0xa1) + 1 */
		 noOfCharacter = ( High - 0xb0 ) * 94 + (Low - 0xa1);

		 /* Level1: 0x8140	to 0x84FC  */
		 if( noOfCharacter >= 752)
			 noOfCharacter += 658;

		 High = noOfCharacter / 188 + 0x81;
		 Low  = noOfCharacter % 188 + 0x40;

		 if( Low >= 0x7F )
			 Low++;

		 *pDest = High;
		 *(pDest + 1) = Low;
	 } else {
		 *pDest = *(pDest+1) = 0x20;
	 }
}
void ConvertStringHtoJ(BYTE  *pSrc, BYTE  *pDst)
{
	 BYTE	c;

	 while( c = *pSrc ) {
		 if( c >= 0xb0 && c <= 0xc9) {
			 HangulToJIS(pSrc, pDst);
			 pSrc += 2;
			 pDst += 2;
		 } else
		 if ( c & 0x80 ) {
			 *pDst++ = *pSrc++;
			 *pDst++ = *pSrc++;
		 } else {
			 *pDst++ = *pSrc++;
		 }
	 }
	 *pDst=0;
}
/**********************     Լ  ()	  ********************/


/******************************************************************************/
/************************* DT 900 ʱ ɼ    ***********************/
/******************************************************************************/

 /**************************************************************************/
 /* 				  +++++   ʱȭ  Լ	 +++++					   */
 /**************************************************************************/
 void Init_Start()
 {
	 int	ret;
	 KEYSEL key_sel;

	 lcd_csr_set(LCD_CSR_OFF);			/* cursor not display		 */

	 key_sel.s		= KEY_MODE_ENA; 	/* shift (S)				 */
	 key_sel.bs 	= KEY_MODE_ENA; 	/* backspace (BS)			 */
	 key_sel.clr	= KEY_MODE_ENA; 	/* clear (CLR)				 */
	 key_sel.ten1	= KEY_MODE_ENA; 	/* ten key 1				 */
	 key_sel.ten2	= KEY_MODE_ENA; 	/* ten key 2				 */
	 key_sel.ten3	= KEY_MODE_ENA; 	/* ten key 3				 */
	 key_sel.ten4	= KEY_MODE_ENA; 	/* ten key 4				 */
	 key_sel.ten5	= KEY_MODE_ENA; 	/* ten key 5				 */
	 key_sel.ten6	= KEY_MODE_ENA; 	/* ten key 6				 */
	 key_sel.ten7	= KEY_MODE_ENA; 	/* ten key 7				 */
	 key_sel.ten8	= KEY_MODE_ENA; 	/* ten key 8				 */
	 key_sel.ten9	= KEY_MODE_ENA; 	/* ten key 9				 */
	 key_sel.ten0	= KEY_MODE_ENA; 	/* ten key 0				 */
	 key_sel.ten	= KEY_MODE_ENA; 	/* period (.)				 */
	 key_sel.ent	= KEY_MODE_ENA; 	/* enter (ENT)				 */
	 key_sel.func1	= KEY_MODE_ENA; 	/* function key 1 (-)		 */
	 key_sel.func2	= KEY_MODE_ENA; 	/* function key 2 (<-)		 */
	 key_sel.func3	= KEY_MODE_ENA; 	/* function key 3 (->)		 */
	 key_sel.func4	= KEY_MODE_ENA; 	/* function key 4 (DEL) 	 */
	 key_sel.func5	= KEY_MODE_ENA; 	/* function key 5 (SP)		 */
	 key_sel.func6	= KEY_MODE_ENA; 	/* function key 6 (^)		 */
	 key_sel.func7	= KEY_MODE_ENA; 	/* function key 7 (v)		 */
	 key_sel.func8	= KEY_MODE_ENA; 	/* function key 8 (BL)		 */
	 key_sel.mltr	= KEY_MODE_ENA; 	/* multi-function key R 	 */
	 key_sel.mltl	= KEY_MODE_ENA; 	/* multi-function key L 	 */
	 key_select(SEL_SET, &key_sel);

	 Init_VAR();
	 Init_SYS();
	 Init_KEY();

	 Init_KeyCode();
 }
 /*-------------------------------------------------------------------+
 |	 Veriable initialize :											  |
 +--------------------------------------------------------------------*/
 void Init_VAR()
 {
	 pMenuCur = P_MNIL;
 }
 /*-------------------------------------------------------------------+
 |	 System initialize :											  |
 |	 ->  Power, Key, OBR, Display, Timer Ʈó ʱȭ			  |
 +--------------------------------------------------------------------*/
 void Init_SYS()
 {
	 ER   errret;

	 /* ---  Power	--- */
     powerMode.apo = 20;              /* APO time set in minutes (00 to 59) */
     powerMode.abo = 30;              /* ABO time set in seconds (00 to 59) */
     powerMode.res_md = RESUME_ON;    /* Resume ON/OFF                      */
     dat_system( SYSD_FNC_WRITE, SYSD_PWR, &powerMode );

	 /* ---  Key Sound	--- */
     keyMode.clk_md = CLICK_ON;     /* Click Sound ON/OFF                 */
     dat_system( SYSD_FNC_WRITE, SYSD_KEY, &keyMode );

	 /* ---  OBR  --- */
     obrMode.rd_ct  = 1L;           /* Scanning count (1 to 9)            */
     obrMode.cmp_ct = 1L;           /* Veritication count (1 to 9)        */
     obrMode.scn_tm = 4L;           /* Scanning time (1 to 9 )            */
     dat_system( SYSD_FNC_WRITE, SYSD_OBR, &obrMode );

	 /* ---  Sound	--- */
     buzzerMode.buzzer = BUZZ_LOUD;    /* Buzzer sound volume                */
									/* (0/1/2/3=off/low/middle/high)	  */
     dat_system( SYSD_FNC_WRITE, SYSD_TIM, &buzzerMode );
 }
 /*-------------------------------------------------------------------+
 |	 Key initialize :												  |
 |	 ->  key_read(), key_string(), key_num() Ʈó ʱȭ		  |
 +--------------------------------------------------------------------*/
 void Init_KEY()
 {
	 key_chr.ext = KEY_LB_EXT;
	 key_chr.echo = ECHO_OFF;
	 key_chr.font_size = LCD_ANK_STANDARD;
	 key_chr.type = LCD_ATTR_NORMAL;
	 key_chr.column_pos = 0;
	 key_chr.line_pos = 0;

	 key_str.ext = KEY_LB_EXT | KEY_CLR_EXT;
	 key_str.echo = ECHO_ON;
	 key_str.font_size = LCD_ANK_STANDARD;
	 key_str.type = LCD_ATTR_NORMAL;
	 key_str.len = 1;
	 key_str.column_pos = 0;
	 key_str.line_pos = 0;
	 key_str.column_len = 1;

	 key_strnum.ext = KEY_LB_EXT | KEY_CLR_EXT;
	 key_strnum.echo = ECHO_ON;
	 key_strnum.font_size = LCD_ANK_STANDARD;
	 key_strnum.type = LCD_ATTR_NORMAL;
	 key_strnum.len = 0;
	 key_strnum.column_pos = 0;
	 key_strnum.line_pos = 0;
	 key_strnum.column_len = 1;
	 key_strnum.clr_type = KEY_NUM_CLR_OFF;
 }
 /*-------------------------------------------------------------------+
 |	 Key code initialize :											  |
 +--------------------------------------------------------------------*/
 void Init_KeyCode()
 {
	 KEYFORM	 fnc_data;

	 fnc_data.attr=0x00;	 fnc_data.code=0x2D;
	 key_fnc( FNC_SET, FNC_1,		 &fnc_data );

	 fnc_data.attr=0x00;	 fnc_data.code=0x1D;
	 key_fnc( FNC_SET, FNC_2,		 &fnc_data );

	 fnc_data.attr=0x00;	 fnc_data.code=0x1C;
	 key_fnc( FNC_SET, FNC_3,		 &fnc_data );

	 fnc_data.attr=0x00;	 fnc_data.code=0x10;
	 key_fnc( FNC_SET, FNC_4,		 &fnc_data );

	 fnc_data.attr=0x00;	 fnc_data.code=0x20;
	 key_fnc( FNC_SET, FNC_5,		 &fnc_data );

	 fnc_data.attr=0xFF;	 fnc_data.code=0x00;
	 key_fnc( FNC_SET, FNC_6,		 &fnc_data );

	 fnc_data.attr=0xFF;	 fnc_data.code=0x01;
	 key_fnc( FNC_SET, FNC_7,		 &fnc_data );

	 fnc_data.attr=0xFF;	 fnc_data.code=0x02;
	 key_fnc( FNC_SET, FNC_8,		 &fnc_data );

	 fnc_data.attr=0xFF;	 fnc_data.code=0x03;
	 key_fnc( FNC_SET, MLT_R,		 &fnc_data );

	 fnc_data.attr=0x00;	 fnc_data.code=0x0D;
	 key_fnc( FNC_SET, MLT_L,		 &fnc_data );
 }
Init_OBR()
{
	ER		ret;

	obrModeTable.Cd39[0] = 0xff; /* reserved							*/
	obrModeTable.Cd39[1] = 2;	 /* minimum number of bar code			*/
	obrModeTable.Cd39[2] = 38;	 /* maximum number of bar code			*/
	obrModeTable.Cd39[3] = 3;	 /* output format						*/
	obrModeTable.Cd39[4] = 0;	 /* direction of check digit execution	*/
	obrModeTable.Cd39[5] = 1;	 /* direction of check character output */

	obrModeTable.Nw7[0] = 0xff;
	obrModeTable.Nw7[1] = 7;
	obrModeTable.Nw7[2] = 18;
	obrModeTable.Nw7[3] = 1;
	obrModeTable.Nw7[4] = 0;
	obrModeTable.Nw7[5] = 0;

	obrModeTable.Wpcea[0] = 0xff;
	obrModeTable.Wpcea[1] = 10;
	obrModeTable.Wpcea[2] = 18;
	obrModeTable.Wpcea[3] = 0;
	obrModeTable.Wpcea[4] = 1;
	obrModeTable.Wpcea[5] = 1;
/* EAN-8, EAN-13 definition */
	obrModeTable.Wpce[0] = 0xff;
	obrModeTable.Wpce[1] = 8;
	obrModeTable.Wpce[2] = 18;
	obrModeTable.Wpce[3] = 0;
	obrModeTable.Wpce[4] = 1;
	obrModeTable.Wpce[5] = 1;

	obrModeTable.Upcea[0] = 0xff;
	obrModeTable.Upcea[1] = 9;
	obrModeTable.Upcea[2] = 12;
	obrModeTable.Upcea[3] = 0;
	obrModeTable.Upcea[4] = 1;
	obrModeTable.Upcea[5] = 1;

	obrModeTable.Upce[0] = 0xff;
	obrModeTable.Upce[1] = 7;
	obrModeTable.Upce[2] = 7;
	obrModeTable.Upce[3] = 1;
	obrModeTable.Upce[4] = 1;
	obrModeTable.Upce[5] = 1;
/* Industrial 2 of 5 definition */
	obrModeTable.Idsf[0] = 0xff;
	obrModeTable.Idsf[1] = 2;
	obrModeTable.Idsf[2] = 40;
	obrModeTable.Idsf[3] = 0;
	obrModeTable.Idsf[4] = 1;
	obrModeTable.Idsf[5] = 1;
/* Interleaved 2 of 5 definition */
	obrModeTable.Itrf[0] = 0xff;
	obrModeTable.Itrf[1] = 4;
	obrModeTable.Itrf[2] = 40;
	obrModeTable.Itrf[3] = 0;
	obrModeTable.Itrf[4] = 1;
	obrModeTable.Itrf[5] = 1;

	obrModeTable.Cd93[0] = 0xff;
	obrModeTable.Cd93[1] = 1;
	obrModeTable.Cd93[2] = 38;
/*	obrModeTable.Cd93[3] = 0;	*/
	obrModeTable.Cd93[4] = 0;
	obrModeTable.Cd93[5] = 1;

	obrModeTable.Cd128[0] = 0xff;
	obrModeTable.Cd128[1] = 1;
	obrModeTable.Cd128[2] = 40;
/*	obrModeTable.Cd128[3] = 0;	*/
	obrModeTable.Cd128[4] = 1;
	obrModeTable.Cd128[5] = 0;

	obrModeTable.Msi[0] = 0xff;
	obrModeTable.Msi[1] = 7;
	obrModeTable.Msi[2] = 12;
	obrModeTable.Msi[3] = 0;
	obrModeTable.Msi[4] = 1;
	obrModeTable.Msi[5] = 1;

	 /* IATA [OBR_IATA] */
	obrModeTable.Iata[0] = 0xff;
	obrModeTable.Iata[1] = 1;
	obrModeTable.Iata[2] = 40;
	obrModeTable.Iata[3] = OBR_OUTOFF;
	obrModeTable.Iata[4] = OBR_CHKDOFF;
	obrModeTable.Iata[5] = OBR_CHKKON;

	obrModeTable.Code = OBR_CD128;		/* Select EAN-13 AND EAN-8 only */
	obrModeTable.Type = OBR_TYPE1;
	obrModeTable.Gain = OBR_GAINL;		/* single reading */
	obrModeTable.Buzc = OBR_BUZON;		/* buzzer control on */
	obrModeTable.Ledc = OBR_LEDON;		/* LED control on */
	obrModeTable.Bufc = OBR_BUFOBR; 	/* seperate OBR buffer */
	obrModeTable.Endc = OBR_ENDCR;		/* CR at end */
	obrModeTable.Mode = OBR_NORM;		/* normal reading */

	ret = OBR_modewt( &obrModeTable );
	if ( ret != E_OK )
		if ( ret == E_PRM )
			return	ERR_PARAMETER;
		else
			return	ERR_OBR_ALREADY_OPEN;

	return	ERR_OK;
}

 int  Init_HANGUL(int flag)
 {
	 ER  errret;

	 switch( flag ) {
		 case FONT_12_DOT :
			 errret = lcd_usrfont(LCD_K6_FILE, "H900-12.FNT");
             displayMode.font_md = FONT6_SET;   /* 6 dot Font mode    */
			 break;

		 case FONT_16_DOT :
			 errret = lcd_usrfont(LCD_K8_FILE, "H900-16.FNT");
             displayMode.font_md = FONT8_SET;   /* 8 dot Font mode    */
			 break;
	 }
     displayMode.lang_md = ENG_SET;     /* English Mode  */
     dat_system( SYSD_FNC_WRITE, SYSD_DSP, &displayMode );

	 if( errret != E_OK ) {
		 return  ERR_HANGUL_FONT;
	 } else {
		 return  ERR_OK;
	 }
 }

/******************************************************************************/
/************************* DT 900 ʱ ɼ   ***********************/
/******************************************************************************/







